<template>
  <div>
    <slot></slot>
  </div>
</template>

<script>
import {provideDatas, provideMethods} from "@/libs/genProvider";
import {findUsers as findUsersAction} from "@/actions/UsersAction";
import {
  addAdminRole as addAdminRoleAction,
  removeAdminRole as removeAdminRoleAction
} from "@/actions/AdminAction";
import {reactFromAPIPut} from "@/libs/reactFromAPI";

export default {
  name: "AdminDashboardProvider",
  inject: ['createAlert'],
  provide() {
    const provider = {};

    provideDatas(provider, 'adminDashboard', this, true);
    provideMethods(provider, 'adminDashboard', this);

    return provider;
  },
  data: () => ({
    searchedWord: "",
    searchingWord: "",
    totalPages: 1,
    currentPage: 1,
    foundUsers: null
  }),
  methods: {
    searchKeyWord() {
      if (this.searchingWord !== this.searchedWord) {
        this.searchedWord = this.searchingWord;
        this.currentPage = 1;
        this.totalPages = 1;
      }
      this.searchUsers();
    },
    setPage(page) {
      this.currentPage = page;
      this.searchingWord = this.searchedWord;
      this.searchUsers();
    },
    searchUsers() {
      findUsersAction(this.currentPage,this.searchedWord === "" ? null : this.searchedWord)
          .then(res => res.json())
          .then(({users,totalPages}) => {
            this.foundUsers = users;
            this.totalPages = totalPages;
          })
    },
    removeOrAddAdminRole(user) {
      return user.roles.includes("ADMIN") ?
          this.removeAdminRole(user) :
          this.addAdminRole(user)
    },
    addAdminRole(user) {
      addAdminRoleAction(user.id)
          .then(res =>
            reactFromAPIPut(
                res,
                {},
                this.createAlert,
                "Rôle administrateur ajouté avec succès!"
            ).then(success => {
              if (!success)
                return;

              this.foundUsers = this.foundUsers.map(eachUser =>
                user.id  === eachUser.id ?
                    {
                      ...eachUser,
                      roles: [eachUser.roles, "ADMIN"]
                    } :
                    eachUser
              )
            })
          )
    },
    removeAdminRole(user) {
      removeAdminRoleAction(user.id)
          .then(res =>
              reactFromAPIPut(
                  res,
                  {},
                  this.createAlert,
                  "Rôle administrateur retiré avec succès!"
              ).then(success => {
                if (!success)
                  return;

                this.foundUsers = this.foundUsers.map(eachUser =>
                    user.id  === eachUser.id ?
                        {
                          ...eachUser,
                          roles: eachUser.roles.filter(role => role !== "ADMIN")
                        } :
                        eachUser
                )
              })
          )
    }
  },
  computed: {
    pages() {
      const pages = [];
      for (let p=1;p<=this.totalPages;p++)
        pages.push(p);
      return pages;
    }
  },
  beforeMount() {
    this.searchUsers();
  }
}
</script>

<style scoped>

</style>
